# サンプルコードについて

これは、WEB+DB PRESS Vol.97の連載「進め！ フロントエンド先遣隊」第6回(最終回)「Web Push APIでプッシュ通知」のサンプルコードです。
紙面で紹介しているサンプルコードは紙幅の関係で簡略化しているため、実際に収録しているものとは差異がある場合があります。

## 準備

サンプルコードの実行には、Node.jsおよびnpmが必要です。
はじめに必要なモジュールをインストールし、その後、鍵ペアの生成を行います。
（リスト5 web-pushモジュールでの鍵ペア生成）
以下のコマンドを実行し、index.jsと同じ階層にkeys.jsonを作成してください。
（パスは各自の環境に合わせて修正してください）

```
$ npm install
$ npm install -g web-push
$ web-push generate-vapid-keys --json > keys.json
```

## サーバの起動

コマンドラインにて以下のコマンドを実行し、サーバを起動します。

```
$ node index.js
```

## サンプルアプリケーション

このサンプルコードは、紙面の構成に合わせた2つのアプリケーションで構成されています。
動作環境はFirefox 51およびChrome 56です。
仕様変更により、これよりも古いバージョンでは動作しない場合があります。

### 1. Notifications API

http://localhost:8000/notifications/

#### 操作方法

「デスクトップ通知の表示許可を要求」ボタンを押すと、ダイアログが表示され、デスクトップ通知の表示許可を求められます。
表示を許可するとフォームが表示されます。
内容を入力して「表示」ボタンをクリックすると、入力内容に応じたデスクトップ通知が表示されます。

#### 対応するコード

* notifications/notifications.js
    * リスト1 表示許可を求める
    * リスト2 デスクトップ通知を表示する
    * リスト3 通知クリック時のイベントリスナを設定

### 2. Web Push

http://localhost:8000/webpush/

#### 操作方法

「デスクトップ通知の表示許可を要求」ボタンを押すと、ダイアログが表示され、デスクトップ通知の表示許可を求められます。
（1.ですでに表示を許可している場合は不要）
購読ボタンを押すとエンドポイント等の情報を含むJSON文字列が表示されますので、これをクリップボードにコピーします。
「コントロールパネル」を開き、先ほどのJSON文字列を「送信先情報」欄に貼り付けます。
あとは1.と同様に内容を入力して「表示」ボタンをクリックすると、入力内容に応じたプッシュ通知が表示されます。
なお、コントロールパネルは別ブラウザで開いても構いません。

#### 対応するコード

* webpush/main.js
    * リスト4 Service Workerの登録
    * リスト6 公開鍵をバイナリ形式へ変換する
    * リスト7 プッシュ通知購読のサンプルコード
* index.js (サーバサイド)
    * リスト8 アプリケーションサーバからプッシュ通知を送信する
* webpush/sw.js (Service Worker)
    * リスト9 プッシュ通知受信時にデスクトップ通知を表示するService Worker
    * リスト10 デスクトップ通知にアクションを追加

## ライセンス

本サンプル中のソースコードは、すべてApacheライセンス2.0とします。

また、EmojiOneの絵文字をアイコンとして使用しています。
EmojiOneは[CC-BY 4.0](https://creativecommons.org/licenses/by/4.0/legalcode)により配布されています。
