"use strict";

document.querySelector('#form').addEventListener('submit', (event) => {
  event.preventDefault();
  let subscriber = event.target.subscriber.value;
  let title = event.target.title.value;
  let body = event.target.body.value;
  let tag = event.target.tag.value;
  let image = event.target.image.value;
  let url = event.target.url.value;
  let actions = event.target.actions.value.split('\n').filter((x) => { return x.length; });
  let subscriberInfo;
  try{
    subscriberInfo = JSON.parse(subscriber);
  }catch (e){
    console.log('送信先情報JSONのパースに失敗しました');
    console.log(e);
    return;
  }

  fetch(
    '/api/push/fire',
    {
      method: 'POST',
      headers: new Headers({
        'Content-Type': 'application/json'
      }),
      body: JSON.stringify({
        subscriber: subscriberInfo,
        title: title,
        body: body,
        tag: tag,
        image: image? `/emoji/${image}.png`: '',
        url: url,
        actions: actions
      })
    }
  );
}, false);