"use strict";

let form = document.querySelector('#form');

form.addEventListener('submit', (event) => {
  let title = event.target.title.value;
  let body = event.target.body.value;
  let tag = event.target.tag.value;
  let image = event.target.image.value;
  let url = event.target.url.value;
  //========================================
  // リスト2 デスクトップ通知を表示する
  let instance = new Notification(
    title,  // 見出し
    {
      body: body, // 本文
      icon: image? `/emoji/${image}.png`: '',
      tag: tag,
      data: { // 任意のデータ
        url: url
      }
    }
  );
  // リスト2 デスクトップ通知を表示する ここまで
  //========================================
  // リスト3 通知クリック時のイベントリスナを設定
  // インスタンスに対しイベントリスナを設定できる
  instance.addEventListener('click', (e) => {
    console.log('通知がクリックされました');
    console.log(e.target);
    // 生成時にdataに格納した記事URLを利用し、
    // Webページを開く
    if(e.target.data.url){
      window.open(e.target.data.url);
    }
  });
  // リスト3 通知クリック時のイベントリスナを設定 ここまで
  //========================================
  event.preventDefault();
});