"use strict";

let requestPermission = document.querySelector('#permission');

if(!('Notification' in window)){
  alert('未対応のブラウザです');
}else if(Notification.permission == 'granted'){
  granted();
}else if(Notification.permission == 'denied'){
  denied();
}else{
  requestPermission.addEventListener('click', () => {
    //========================================
    // リスト1 表示許可を求める
    Notification.requestPermission()
      .then((permission) => {
        // Notification.permissionにも
        // 引数と同じ値が格納されている
        if(permission == 'granted'){
          // 許可された場合
          console.log('許可されました');
          granted();
        }else if(permission == 'denied') {
          // ブロックされた場合
          console.log('ブロックされました');
          denied();
        }else if(permission == 'default'){
          // 無視された場合
          console.log('無視されました');
        }
      });
    // リスト1 表示許可を求める ここまで
    //========================================
  }, false);
}

function granted(){
  requestPermission.innerHTML = 'デスクトップ通知の表示は許可済です';
  requestPermission.disabled = true;
}

function denied(){
  requestPermission.innerHTML = 'デスクトップ通知がブロックされています';
  requestPermission.disabled = true;
}