"use strict";

self.addEventListener('install', (event) => {
  event.waitUntil(skipWaiting());
});

self.addEventListener('activate', (event) => {
  event.waitUntil(self.clients.claim());
});

self.addEventListener('push', (event) => {
  console.log('プッシュ通知を受信！');
  // (12)イベント
  // (13)デスクトップ通知を表示
  if(!event.data){
    return;
  }
  // ペイロードをJSON形式でパースして取得
  // .text()、.arrayBuffer()、.blob()も利用可能
  let data = event.data.json();
  event.waitUntil(this.registration.showNotification(
      data.title,
      {
        body: data.body,
        icon: data.image || '',
        tag: data.tag,
        data: {
          url: data.url
        },
        actions: data.actions || []
      }
    )
  );
});
// プッシュ通知クリック時のイベント
self.addEventListener('notificationclick', (event) => {
  // notificationプロパティの中身は
  // Notificationオブジェクト
  let notification = event.notification;
  if(event.action){
    console.log('「' + event.action + '」がクリックされました');
  }else{
    let url = notification.data.url;
    event.waitUntil(self.clients.openWindow(url));
  }
});
