"use strict";
// Expressを利用し、8000ポートでサーバを起動
const http = require('http');
const webpush = require('web-push');
const express = require('express');
const bodyParser = require('body-parser');
const app = express();

app.use(bodyParser.json());
app.use(express.static(__dirname + '/htdocs/'));
app.listen(8000, '0.0.0.0');

const contact = 'mailto:foo@example.jp';
// 鍵ペアはkeys.jsonから読み込み
const keys = require('./keys.json');
webpush.setVapidDetails(contact, keys.publicKey, keys.privateKey);

app.post('/api/push/fire', (req, res) => {
  // プッシュ通知の送信先情報（実際にはDB等から取得）
  // このサンプルでは、コントロールパネルから送信された情報を利用
  let subscription = req.body.subscriber;
  // プッシュ通知で送信したい任意のデータ
  let actions = req.body.actions.map((x) => {
    return {action: x, title: x};
  });
  let payload = JSON.stringify({
    title: req.body.title,
    body: req.body.body,
    image: req.body.image,
    tag: req.body.tag,
    url: req.body.url,
    actions: actions
  });
  // (9)通知送信
  webpush.sendNotification(subscription, payload);
  res.send('');
});

app.get('/serverkey.js', (rew, res) => {
  res
    .type('javascript')
    .status(200)
    .send('let serverKey = "' + keys.publicKey + '";');
});